package xyz.etztech.deluxegroups.listeners;

import github.scarsz.discordsrv.DiscordSRV;
import github.scarsz.discordsrv.dependencies.commons.lang3.StringUtils;
import github.scarsz.discordsrv.dependencies.dev.vankka.mcdiscordreserializer.discord.DiscordSerializer;
import github.scarsz.discordsrv.dependencies.jda.api.entities.TextChannel;
import github.scarsz.discordsrv.dependencies.net.kyori.text.serializer.legacy.LegacyComponentSerializer;
import github.scarsz.discordsrv.hooks.VaultHook;
import github.scarsz.discordsrv.hooks.world.MultiverseCoreHook;
import github.scarsz.discordsrv.util.DiscordUtil;
import github.scarsz.discordsrv.util.LangUtil;
import github.scarsz.discordsrv.util.PlaceholderUtil;
import github.scarsz.discordsrv.util.TimeUtil;
import org.bukkit.ChatColor;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import xyz.etztech.deluxegroups.DeluxeGroups;
import xyz.etztech.deluxegroups.events.GlobalChatEvent;
import xyz.etztech.deluxegroups.events.GroupChatEvent;

import static org.bukkit.Bukkit.getServer;

public class DGListener implements Listener {

    private DeluxeGroups plugin;

    public DGListener(DeluxeGroups deluxeGroups) {
        this.plugin = deluxeGroups;
    }

    @EventHandler
    public void onGlobalChat(GlobalChatEvent event) {
        TextChannel mainChannel = DiscordSRV.getPlugin().getMainTextChannel();

        // FIXME Do we really need to copy/paste DiscordSRV code??
        String channel = mainChannel.getName();
        String message = event.getMessage();
        Player player = event.getAuthor();
        String userPrimaryGroup = VaultHook.getPrimaryGroup(player);
        boolean hasGoodGroup = StringUtils.isNotBlank(userPrimaryGroup);
        if (hasGoodGroup) {
            userPrimaryGroup = userPrimaryGroup.substring(0, 1).toUpperCase() + userPrimaryGroup.substring(1);
        }

        boolean reserializer = DiscordSRV.config().getBoolean("Experiment_MCDiscordReserializer_ToDiscord");
        String username = DiscordUtil.strip(player.getName());
        if (!reserializer) {
            username = DiscordUtil.escapeMarkdown(username);
        }

        String discordMessage = (hasGoodGroup ? LangUtil.Message.CHAT_TO_DISCORD.toString() : LangUtil.Message.CHAT_TO_DISCORD_NO_PRIMARY_GROUP.toString()).replaceAll("%time%|%date%", TimeUtil.timeStamp()).replace("%channelname%", channel != null ? channel.substring(0, 1).toUpperCase() + channel.substring(1) : "").replace("%primarygroup%", userPrimaryGroup).replace("%username%", username).replace("%world%", player.getWorld().getName()).replace("%worldalias%", DiscordUtil.strip(MultiverseCoreHook.getWorldAlias(player.getWorld().getName())));
        discordMessage = PlaceholderUtil.replacePlaceholdersToDiscord(discordMessage, player);
        String displayName = DiscordUtil.strip(player.getDisplayName());
        if (reserializer) {
            message = DiscordSerializer.INSTANCE.serialize(LegacyComponentSerializer.legacy().deserialize(message));
        } else {
            displayName = DiscordUtil.escapeMarkdown(displayName);
        }

        discordMessage = discordMessage.replace("%displayname%", displayName).replace("%message%", message);
        if (!reserializer) {
            discordMessage = DiscordUtil.strip(discordMessage);
        }
        if (DiscordSRV.config().getBoolean("DiscordChatChannelTranslateMentions")) {
            discordMessage = DiscordUtil.convertMentionsFromNames(discordMessage, DiscordSRV.getPlugin().getMainGuild());
        } else {
            discordMessage = discordMessage.replace("@", "@\u200b");
        }
        DiscordUtil.sendMessage(mainChannel, discordMessage);
    }

    @EventHandler
    public void onGroupChat(GroupChatEvent event) {
        TextChannel groupChannel = DiscordSRV.getPlugin().getDestinationTextChannelForGameChannelName(event.getGroup().getName());
        if (groupChannel != null) {
            String discordFormat = plugin.getConfig().getString("discord.mtd", "<author> > <message>");
            String message = discordFormat.
                    replace("<group>", event.getGroup().getName()).
                    replace("<message>", ChatColor.stripColor(event.getMessage())).
                    replace("<author>", event.getAuthor().getName());
            groupChannel.sendMessage(message).queue();
        }
    }
}
